from ndspy.fnt import Folder

from ndspy.code import MainCodeFile, Overlay

from . import code as code
from typing import Any, Dict, List

ICON_BANNER_LEN: int


class NintendoDSRom:
    arm9: bytes
    arm9PostData: bytes
    arm9OverlayTable: bytes
    arm7: bytes
    files: List[bytes]
    filenames: Folder
    idCode: bytes
    iconBanner: bytes
    name: bytes

    def __init__(self, data: Any | None = ...) -> None: ...
    @classmethod
    def fromFile(cls, filePath: str) -> NintendoDSRom: ...

    deviceCapacity: Any

    def save(self, *, updateDeviceCapacity: bool = ...) -> bytes: ...
    def saveToFile(
        self, filePath: str, *, updateDeviceCapacity: bool = ...
    ) -> None: ...
    def loadArm9(self) -> MainCodeFile: ...
    def loadArm7(self) -> MainCodeFile: ...
    def loadArm9Overlays(
        self, idsToLoad: List[int] | None = ...
    ) -> Dict[int, Overlay]: ...
    def loadArm7Overlays(
        self, idsToLoad: List[int] | None = ...
    ) -> Dict[int, Overlay]: ...
    def getFileByName(self, filename: str) -> bytes: ...
    def setFileByName(self, filename: str, data: bytes) -> None: ...
